function IntroScript(that){
	// Game Rules
	this.scene.setRule("world", "void");
	this.scene.setRule("canShoot", false);
	this.scene.setRule("useBounds", false);
	
	localStorage.SpaceWizard = localStorage.SpaceWizard ? localStorage.SpaceWizard : "MA==";
	try{ if(parseInt(atob(localStorage.SpaceWizard)) != atob(localStorage.SpaceWizard)) throw new Error("L O L :P"); } catch(e){ localStorage.SpaceWizard = "MA=="; }
	
	// Script Rules
	this.setQuality(1);
	
	
	var dialogue = `
		n:YOU ARE THE POWERFUL WIZARD, ZIMON\\nONE DAY WHILST EXPERIMENTING IN YOUR LAB\\nYOU SLIP AND CRUSH A VERY POWERFUL ARTIFACT...
		n:YOU ARE CONSUMED IN A FLASH OF LIGHT,\\nAND WAKE UP IN A TIME THAT IS NOT YOUR OWN...
		s:WHAT KIND OF-
		w:WHAT?
		s:WHAT?
		w:I AM ZIMON.
		s:SIMON?
		w:Z I M O N.
		s:LOOK MAN, I DONT KNOW WHAT YOU'RE DOIN' OUT.\\nBUT THERE'S AN INVASION HAPPENING. \\nCIVILIANS AREN'T SAFE OUT OF THE BUNKERS.
		w:DO NOT FRET, I AM NO PEASANT!\\n WATCH THIS, KNIGHT!
		s:...KNIGHT?
		n: YOU CAST A FORCE BUBBLE AROUND YOURSELF\\nAND LITERALLY JUMP INTO SPACE
		s:OH...
		s:I SEE...
	`;
	
	
	var lines = dialogue.trim().split("\n"),
		lineIndex = 0,
		lineMaxLength = 0,
		lineMaxHeight = 0,
		animation1,
		animation2,
		animation3,
		headType,
		headOpacity,
		currentLine;
	
	var hintOpacityMult = 0;
	
	var tt1 = "SPACE: NEXT",
		ts1 = textSize(tt1, that.atlas.gui.font.white, 0.6);
	
	var tt2 = "ENTER: SKIP",
		ts2 = textSize(tt2, that.atlas.gui.font.white, 0.6);
	
	
	procLine(0);
	
	function procLine(index){
		var line = lines[lineIndex].trim().split("\\n").join("\n");
		if(animation1) that.animations.remove(animation1);
		if(animation2) that.animations.remove(animation2);
		if(animation3) that.animations.remove(animation3);
		
		headType = line[0] === "s" ? "soldierHead" : (line[0] === "w" ? "wizardHead" : "none");
		line = (line[0] === "s" ? "        " : (line[0] === "w" ? "    " : "none")) + line.slice(2).trim();
		currentLine = "";
		
		lineMaxLength = 0;
		lineMaxHeight = 0;
		headOpacity = 0;
		
		line.split("\n").forEach(function(l){ if(l.length > lineMaxLength) lineMaxLength = l.length; lineMaxHeight++; });
		
		animation1 = that.animations.add(function(i){ headOpacity = i; }, null, 0.3);
		animation2 = that.animations.add(function(i){ currentLine = line.slice(0, Math.floor(i * line.length)) + (i === 1 ? "" : "|"); }, null, line.length * 0.015);
		animation3 = that.animations.add(function(i){ hintOpacityMult = Math.max(0, i * 10 - 9.5) * 2; }, null, 3);
	}
	
	
	function done(){
		that.animations.add(null, function(i){
			that.context.globalAlpha = 1 - i;
			that.context.fillStyle = "#000";
			that.context.fillRect(0, 0, that.ratio.width, that.ratio.height);
			that.context.globalAlpha = 1;
		}, 0.6);
		
		that.stateUpdate = function(){};
		MenuScript.call(that, that);
	}
	
	
	
	this.stateUpdate = function(){
		if(that.input.keys[32]){
			delete that.input.keys[32];
			
			if(lines[++lineIndex]) procLine(lineIndex);
			else done();
		}
		
		if(that.input.keys[13]){
			delete that.input.keys[13];
			done();
		}
	};
	
	
	this.stateDraw = function(context, textures, atlas){
		var scale = 0.6,
			factor = 60,
			headPosition = headType === "wizardHead" ? 1 : 0,
			lineWidth = (lineMaxLength * that.atlas.gui.font.white[0][2] + lineMaxLength - 1)  * scale,
			lineHeight = (lineMaxHeight * that.atlas.gui.font.white[0][3] + lineMaxHeight - 1)  * scale,
			offsetX,
			offsetY;
		
		if(headType !== "none"){
			offsetX = headPosition ? factor : this.ratio.width/this.scale - textures[headType].width * scale - factor;
			offsetY = this.ratio.height/this.scale/2 - textures[headType].height/2 + (2 - 2 * ease(headOpacity/2 + 0.5)) * 20 + 10;
			context.globalAlpha = headOpacity;
			context.drawImage(textures[headType], offsetX, offsetY, textures[headType].width * scale, textures[headType].height * scale);
			
			offsetX = (this.ratio.width/this.scale - textures[headType].width * scale - factor * (headType === "wizardHead" ? 2 : 1)) / 2 - lineWidth/2 + headPosition * (textures[headType].width * scale + factor);
			offsetY = this.ratio.height/this.scale/2 - lineHeight/2
			
			context.globalAlpha = 0.4;
			drawText(that.context, that.textures, that.atlas, that.atlas.gui.font.white, headType === "wizardHead" ? "YOU:" : "SOLDIER:", offsetX, offsetY, scale);
			context.globalAlpha = 1;
		}
		
		else{
			offsetX = this.ratio.width/this.scale / 2 - lineWidth/2;
			offsetY = this.ratio.height/this.scale/2 - lineHeight/2
		}
		
		drawText(that.context, that.textures, that.atlas, that.atlas.gui.font.white, currentLine, offsetX, offsetY, scale);
		
		context.globalAlpha = 0.4 * hintOpacityMult;
		drawText(that.context, that.textures, that.atlas, that.atlas.gui.font.white, tt1, 32, 2, 0.6);
		drawText(that.context, that.textures, that.atlas, that.atlas.gui.font.white, tt2, that.ratio.width/that.scale - ts1.width - 32, 2, 0.6);
		context.globalAlpha = 1;
	};
	
	
	function textSize(text, font, scale){
		var width = 0,
			height = font[0][3];
		
		for(var i=0; i<text.length; i++){
			var map = font[that.atlas.gui.fontMap.indexOf(text[i])] || font[font.length-1];
			if(text[i] === "\n") height += map[3] + 1;
			else width += map[2] + 1;
		}
		
		return { width: width * scale, height: height * scale };
	}
}
